<?php

namespace Televox\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class eliminarArchivos extends Controller
{
    public function eliminar(Request $request, $id)
    {
        if (!$request->session()->get('eliminar', false)) {
            return ['Estado' => 'error', 'Descripcion' => 'No tiene permisos para eliminar grabaciones'];
        } else {
            switch (env('TIPO', 2)) {
                case 2:
                case 4:
                    $datos = $request->validate([
                        'archive' => 'boolean|required',
                    ]);
                    $recording_log = 'recording_log';
                    if (array_key_exists('archive', $datos) && $datos['archive'] != null && $datos['archive'] == true) {
                        $recording_log = 'recording_log_archive';
                    }
                    $result = DB::connection('Dialvox')->table("$recording_log AS rl")->where('rl.recording_id', '=', $id)->where('rl.filename', 'LIKE', '%_' . $request->session()->get('idClientes'))->addSelect('rl.recording_id AS Nombre')->addSelect(DB::raw("date(rl.start_time) as 'FechaInicio'"))->addSelect(DB::raw("time(rl.start_time) AS 'HoraInicio'"))->addSelect(DB::raw("time(rl.end_time) AS 'HoraFin'"))->addSelect(DB::raw("sec_to_time(rl.length_in_sec) AS 'Duracion'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('rl.user')->addSelect(DB::raw("substr(rl.location,Locate('MP3/',rl.location)+4) AS 'GRAB_FILE'"))->addSelect('rl.extension AS phone_number')->addSelect('rl.lead_id AS lead_id')->first();
                    if ($result) {
                        $RUTA_COMPLETA = \env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE";
                        if ($RUTA_COMPLETA) {
                            if (file_exists($RUTA_COMPLETA)) {
                                if (unlink($RUTA_COMPLETA)) {
                                    DB::connection('Dialvox')->table("$recording_log")->where('recording_id', '=', "$result->Nombre")->delete();
                                    DB::connection('Televox')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);

                                    return ['Estado' => 'ok'];
                                } else {
                                    return ['Estado' => 'error', 'Descripcion' => 'No se pudo borrar la grabacion'];
                                }
                            } else {
                                $RUTA_COMPLETA = \env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . str_replace('-', '/', $result->FechaInicio) . '/' . str_replace(str_replace('-', '/', $result->FechaInicio) . '/', '', $result->GRAB_FILE);
                                if (file_exists($RUTA_COMPLETA)) {
                                    if (unlink($RUTA_COMPLETA)) {
                                        DB::connection('Dialvox')->table("$recording_log")->where('recording_id', '=', "$result->Nombre")->delete();
                                        DB::connection('Televox')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);

                                        return ['Estado' => 'ok'];
                                    } else {
                                        return ['Estado' => 'error', 'Descripcion' => 'No se pudo borrar la grabacion'];
                                    }
                                } else {
                                    return ['Estado' => 'error', 'Descripcion' => 'No se pudo borrar la grabacion'];
                                }
                            }

                        } else {
                            return ['Estado' => 'error', 'Descripcion' => 'No existe el archivo de la grabacion', 'DIRECCION' => $RUTA_COMPLETA];
                        }
                    } else {
                        return ['Estado' => 'error', 'Descripcion' => 'Grabacion no encontrada'];
                    }
                    break;
                case 3:
                    $result = DB::connection('Dialvox')->table('aurolog_grabaciones')->whereRaw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) = ?", [$id])->addSelect('idGrabacion')->addSelect('ANI')->addSelect(DB::raw("CONCAT(DNIS,' ',digitos) as 'Destino'"))->addSelect(DB::raw("sec_to_time(hora) as 'horai'"))->addSelect(DB::raw("sec_to_time(hora+duracion) as 'horaf'"))->addSelect(DB::raw("sec_to_time(duracion) as 'duracion'"))->addSelect('extension')->addSelect(DB::raw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY) as 'fecha'"))->addSelect(DB::raw("substr(archivoVoz,Locate('/2',archivoVoz)+1) as 'GRAB_FILE'"))->addSelect(DB::raw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) as 'GRAB_ID'"))->first();
                    if ($result) {
                        if (\file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                            if (unlink(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                DB::connection('Dialvox')->table('aurolog_grabaciones')->where('idGrabacion', '=', "$result->idGrabacion")->delete();
                                DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->extension: Fecha: $result->fecha Hora: $result->horai"]);

                                return ['Estado' => 'ok'];
                            } else {
                                return ['Estado' => 'error', 'Descripcion' => 'No se pudo borrar la grabacion'];
                            }

                        } else {
                            return ['Estado' => 'error', 'Descripcion' => 'No existe el archivo de la grabacion'];
                        }
                    } else {
                        return ['Estado' => 'error', 'Descripcion' => 'Grabacion no encontrada'];
                    }
                    break;
                case 1:
                    $result = DB::connection('Dialvox')->table('grab')->where('GRAB_ID', '=', $id)->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_E,2),':',LEFT(RIGHT(GRAB_TIME_E,4),2),':',RIGHT(GRAB_TIME_E,2)) as 'GRAB_TIME_E'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),':',RIGHT(GRAB_TIME_S,2)) as 'GRAB_TIME_S'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_DATE,4),'/',LEFT(RIGHT(GRAB_DATE,4),2),'/',RIGHT(GRAB_DATE,2)) as 'GRAB_DATE'"))->addSelect('GRAB_FILE')->addSelect('GRAB_IP')->addSelect('GRAB_ID')->addSelect('GRAB_MACHINE')->addSelect('GRAB_EXT')->addSelect(DB::raw("TIME_FORMAT(SEC_TO_TIME(GRAB_DURATION),'%H:%i:%s') as 'GRAB_DURATION'"));
                    if ($result) {
                        if (\file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                            if (unlink(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                DB::connection('Dialvox')->table('grab')->where('GRAB_ID', '=', "$result->GRAB_ID")->delete();
                                DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->GRAB_EXT: Fecha: $result->GRAB_DATE Hora: $result->GRAB_TIME_S"]);

                                return ['Estado' => 'ok'];
                            } else {
                                return ['Estado' => 'error', 'Descripcion' => 'No se pudo borrar la grabacion'];
                            }

                        } else {
                            return ['Estado' => 'error', 'Descripcion' => 'No existe el archivo de la grabacion'];
                        }
                    } else {
                        return ['Estado' => 'error', 'Descripcion' => 'Grabacion no encontrada'];
                    }
                    break;
            }
        }
    }

    public function eliminarVarios(Request $request)
    {

        if (!$request->session()->get('eliminar', false)) {
            return ['Estado' => 'error', 'Descripcion' => 'No tiene permisos para eliminar grabaciones'];
        } else {
            $string = '';
            $errores = [];
            switch (env('TIPO', 2)) {
                case 2:
                case 4:
                    $datos = $request->validate([
                        'tipoLlam' => 'numeric|between:-1,1|nullable',
                        'identificador' => 'numeric|nullable',
                        'usuario' => 'alpha_num|nullable',
                        'nombre' => 'string|nullable',
                        'telefono' => 'alpha_num|nullable',
                        'cuenta' => 'alpha_num|nullable',
                        'segundosinicial' => 'between:0,59|numeric|required_with_all:minutosinicial,horasinicial',
                        'minutosinicial' => 'between:0,59|numeric|required_with_all:segundosinicial,horasinicial',
                        'horasinicial' => 'between:0,23|numeric|required_with_all:minutosinicial,segundosinicial',
                        'segundosfinal' => 'between:0,59|numeric|required_with_all:minutosfinal,horasfinal',
                        'minutosfinal' => 'between:0,59|numeric|required_with_all:segundosfinal,horasfinal',
                        'horasfinal' => 'between:0,23|numeric|required_with_all:minutosfinal,segundosfinal',
                        'inicio' => 'before_or_equal:today|date|required_with_all:fminutosinicial,fhorasinicial,fsegundosinicial',
                        'fin' => 'after_or_equal:inicio|before_or_equal:today|date|required_with_all:fminutosfinal,fhorasfinal,fsegundosfinal',
                        'fminutosinicial' => 'between:0,59|numeric|required_with_all:fminutosinicial,fhorasinicial,inicio',
                        'fminutosinicial' => 'between:0,59|numeric|required_with_all:fsegundosinicial,fhorasinicial,inicio',
                        'fhorasinicial' => 'between:0,23|numeric|required_with_all:fminutosinicial,fsegundosinicial,inicio',
                        'fsegundosfinal' => 'between:0,59|numeric|required_with_all:fminutosfinal,fhorasfinal,fin',
                        'fminutosfinal' => 'between:0,59|numeric|required_with_all:fsegundosfinal,fhorasfinal,fin',
                        'fhorasfinal' => 'between:0,23|numeric|required_with_all:fminutosfinal,fsegundosfinal,fin',
                        'pagina' => 'gte:0|numeric|required',
                        'status' => 'numeric|nullable',
                        'escuchando' => 'boolean|nullable',
                        'archive' => 'boolean|required',
                        'campaign_id' => 'nullable|string|required_with:list_id,status_id',
                        'list_id' => 'nullable|string|required_with:status_id',
                        'status_id' => 'nullable|string',
                        'ingroup_id' => 'nullable|string',
                    ]);
                    $recording_log = 'recording_log';
                    if (array_key_exists('archive', $datos) && $datos['archive'] != null && $datos['archive'] == true) {
                        $recording_log = 'recording_log_archive';
                    }

                    $filtros = [];
                    if (array_key_exists('status', $datos) && $datos['status'] != null && $datos['status'] != 0) {
                        $filtros[] = ['ts.idStatus', '=', $datos['status']];
                    }
                    if (array_key_exists('campaign_id', $datos) && $datos['campaign_id'] != null) {
                        $filtros[] = ['vc.campaign_id', '=', $datos['campaign_id']];
                        if (array_key_exists('list_id', $datos) && $datos['list_id'] != null) {
                            $filtros[] = ['vls.list_id', '=', $datos['list_id']];
                        }
                        if (array_key_exists('status_id', $datos) && $datos['status_id'] != null) {
                            $filtros[] = ['vl.status', '=', $datos['status_id']];
                        }
                    } else {
                        if (array_key_exists('ingroup_id', $datos) && $datos['ingroup_id'] != null) {
                            $filtros[] = ['vc.campaign_id', '=', $datos['ingroup_id']];
                        }
                    }
                    $filtros[] = ['rl.filename', 'LIKE', '%_' . $request->session()->get('idClientes')];

                    if (array_key_exists('cuenta', $datos) && $datos['cuenta'] != null) {
                        $filtros[] = ['vl.vendor_lead_code', 'LIKE', "%{$datos['cuenta']}%"];
                    }
                    if (array_key_exists('identificador', $datos) && $datos['identificador'] != null) {
                        $filtros[] = ['rl.recording_id', '=', "{$datos['identificador']}"];
                    }
                    if (array_key_exists('telefono', $datos) && $datos['telefono'] != null) {
                        $filtros[] = ['rl.extension', 'LIKE', "%{$datos['telefono']}%"];
                    }
                    if (array_key_exists('nombre', $datos) && $datos['nombre'] != null) {
                        $filtros[] = ['rl.filename', 'LIKE', "%{$datos['nombre']}%"];
                    }
                    if (array_key_exists('usuario', $datos) && $datos['usuario'] != null) {
                        $filtros[] = ['rl.user', 'LIKE', "%{$datos['usuario']}%"];
                    }
                    if (array_key_exists('segundosinicial', $datos) && $datos['segundosinicial'] != null) {
                        $filtros[] = ['rl.length_in_sec', '>=', $datos['segundosinicial'] + $datos['minutosinicial'] * 60 + $datos['horasinicial'] * 3600];
                    }
                    if (array_key_exists('segundosfinal', $datos) && $datos['segundosfinal'] != null) {
                        $filtros[] = ['rl.length_in_sec', '<=', $datos['segundosfinal'] + $datos['minutosfinal'] * 60 + $datos['horasfinal'] * 3600];
                    }
                    if (array_key_exists('tipoLlam', $datos) && $datos['tipoLlam'] != null) {
                        if ($datos['tipoLlam'] > 0) {
                            $filtros[] = ['rl.filename', 'LIKE', 'IN_%'];
                        } else {
                            if ($datos['tipoLlam'] < 0) {
                                $filtros[] = ['rl.filename', 'LIKE', 'OUT_%'];
                            }
                        }
                    }
                    if ((array_key_exists('campaign_id', $datos) && $datos['campaign_id'] != null) || (array_key_exists('cuenta', $datos) && $datos['cuenta'] != null)) {
                        $results = DB::connection('Televox')->table("$recording_log as rl")->crossJoin('vicidial_list AS vl')->leftJoin('tbl_status_grab AS tsg', 'tsg.id_grab', '=', 'rl.filename')->leftJoin('tbl_status AS ts', 'tsg.id_status', '=', 'ts.idStatus')->leftJoin('audios_listen AS al', 'al.id_grab', '=', 'rl.filename')->join('vicidial_lists AS vls', 'vls.list_id', '=', 'vl.list_id')->join('vicidial_campaigns AS vc', 'vc.campaign_id', '=', 'vls.campaign_id')->whereRaw('rl.lead_id=vl.lead_id')->where($filtros)->where(function ($q) use ($datos) {
                            if (array_key_exists('inicio', $datos)) {
                                $q->where(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('rl.start_time', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                                })->orWhere(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', '>', date('Y-m-d', strtotime($datos['inicio'])));
                                });
                            }

                        })->where(function ($q) use ($datos) {
                            if (array_key_exists('fin', $datos)) {
                                $q->where(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['fin'])))->whereTime('rl.start_time', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                                })->orWhere(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', '<', date('Y-m-d', strtotime($datos['fin'])));
                                });
                            }
                        })->where(function ($q) use ($request) {
                            $q->where(function ($qq) use ($request) {
                                $qq->where('al.id_usuario', '=', $request->session()->get('id'));
                            })->orWhere(function ($qq) {
                                $qq->whereRaw('al.id_usuario IS NULL');
                            });
                        });

                    } else {
                        if (array_key_exists('ingroup_id', $datos) && $datos['ingroup_id'] != null) {
                            $results = DB::connection('Televox')->table("$recording_log as rl")->join('vicidial_closer_log AS vc', 'vc.vicidial_id', '=', 'vc.closecallid')->leftJoin('tbl_status_grab AS tsg', 'tsg.id_grab', '=', 'rl.filename')->leftJoin('tbl_comentarios AS tc', 'tc.id_grab', '=', 'rl.filename')->leftJoin('tbl_status AS ts', 'tsg.id_status', '=', 'ts.idStatus')->leftJoin('audios_listen AS al', 'al.id_grab', '=', 'rl.filename')->where($filtros)->where(function ($q) use ($datos) {
                                if (array_key_exists('inicio', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('rl.start_time', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '>', date('Y-m-d', strtotime($datos['inicio'])));
                                    });
                                }

                            })->where(function ($q) use ($datos) {
                                if (array_key_exists('fin', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['fin'])))->whereTime('rl.start_time', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '<', date('Y-m-d', strtotime($datos['fin'])));
                                    });
                                }
                            })->where(function ($q) use ($request) {
                                $q->where(function ($qq) use ($request) {
                                    $qq->where('al.id_usuario', '=', $request->session()->get('id'));
                                })->orWhere(function ($qq) {
                                    $qq->whereRaw('al.id_usuario IS NULL');
                                });
                            });

                        } else {
                            $results = DB::connection('Televox')->table("$recording_log as rl")->leftJoin('tbl_status_grab AS tsg', 'tsg.id_grab', '=', 'rl.filename')->leftJoin('tbl_comentarios AS tc', 'tc.id_grab', '=', 'rl.filename')->leftJoin('tbl_status AS ts', 'tsg.id_status', '=', 'ts.idStatus')->leftJoin('audios_listen AS al', 'al.id_grab', '=', 'rl.filename')->where($filtros)->where(function ($q) use ($datos) {
                                if (array_key_exists('inicio', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('rl.start_time', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '>', date('Y-m-d', strtotime($datos['inicio'])));
                                    });
                                }

                            })->where(function ($q) use ($datos) {
                                if (array_key_exists('fin', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['fin'])))->whereTime('rl.start_time', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '<', date('Y-m-d', strtotime($datos['fin'])));
                                    });
                                }
                            })->where(function ($q) use ($request) {
                                $q->where(function ($qq) use ($request) {
                                    $qq->where('al.id_usuario', '=', $request->session()->get('id'));
                                })->orWhere(function ($qq) {
                                    $qq->whereRaw('al.id_usuario IS NULL');
                                });
                            });
                        }

                    }
                    $results = $results->limit(1000)->addSelect('rl.recording_id as Nombre')->addSelect(DB::raw("date(rl.start_time) as 'FechaInicio'"))->addSelect(DB::raw("time(rl.start_time) as 'HoraInicio'"))->addSelect(DB::raw("time(rl.end_time) as 'HoraFin'"))->addSelect(DB::raw("sec_to_time(rl.length_in_sec) as 'Duracion'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('rl.user')->addSelect(DB::raw("substr(rl.location,Locate('MP3/',rl.location)+4) AS 'GRAB_FILE'"))->addSelect('rl.extension AS phone_number')->addSelect('rl.lead_id AS lead_id')->get();
                    foreach ($results as $result) {
                        if (\file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                            if (unlink(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                DB::connection('Dialvox')->table("$recording_log")->where('recording_id', '=', "$result->Nombre")->delete();
                                DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                            } else {
                                $errores[] = "No se pudo borrar la grabacion: '$result->GRAB_ID'";
                            }
                        } else {
                            if (\file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . str_replace('-', '/', $result->FechaInicio) . '/' . str_replace(str_replace('-', '/', $result->FechaInicio) . '/', '', $result->GRAB_FILE))) {
                                if (unlink(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . str_replace('-', '/', $result->FechaInicio) . '/' . str_replace(str_replace('-', '/', $result->FechaInicio) . '/', '', $result->GRAB_FILE))) {
                                    DB::connection('Dialvox')->table("$recording_log")->where('recording_id', '=', "$result->Nombre")->delete();
                                    DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                } else {
                                    $errores[] = "No se pudo borrar la grabacion: '$result->GRAB_ID'";
                                }
                            } else {

                                $errores[] = "No existe el archivo de la grabacion: '$result->GRAB_ID'";
                            }

                        }
                    }
                    break;
                case 3:
                    $datos = $request->validate([
                        'nombre' => 'string',
                        'extension' => 'numeric',
                        'origen' => 'string',
                        'destino' => 'numeric',
                        'segundosinicial' => 'between:0,59|numeric|required_with_all:minutosinicial,horasinicial',
                        'minutosinicial' => 'between:0,59|numeric|required_with_all:segundosinicial,horasinicial',
                        'horasinicial' => 'between:0,23|numeric|required_with_all:minutosinicial,segundosinicial',
                        'segundosfinal' => 'between:0,59|numeric|required_with_all:minutosfinal,horasfinal',
                        'minutosfinal' => 'between:0,59|numeric|required_with_all:segundosfinal,horasfinal',
                        'horasfinal' => 'between:0,23|numeric|required_with_all:minutosfinal,segundosfinal',
                        'inicio' => 'before_or_equal:today|date|required_with_all:fminutosinicial,fhorasinicial,fsegundosinicial',
                        'fin' => 'after_or_equal:inicio|before_or_equal:today|date|required_with_all:fminutosfinal,fhorasfinal,fsegundosfinal',
                        'fminutosinicial' => 'between:0,59|numeric|required_with_all:fminutosinicial,fhorasinicial,inicio',
                        'fminutosinicial' => 'between:0,59|numeric|required_with_all:fsegundosinicial,fhorasinicial,inicio',
                        'fhorasinicial' => 'between:0,23|numeric|required_with_all:fminutosinicial,fsegundosinicial,inicio',
                        'fsegundosfinal' => 'between:0,59|numeric|required_with_all:fminutosfinal,fhorasfinal,fin',
                        'fminutosfinal' => 'between:0,59|numeric|required_with_all:fsegundosfinal,fhorasfinal,fin',
                        'fhorasfinal' => 'between:0,23|numeric|required_with_all:fminutosfinal,fsegundosfinal,fin',
                        'pagina' => 'gte:0|numeric|required',
                    ]);
                    $filtros = [];
                    if (array_key_exists('nombre', $datos) && $datos['nombre'] != null) {
                        $filtros[] = ['idGrabacion', 'LIKE', "%{$datos['nombre']}%"];
                    }
                    if (array_key_exists('origen', $datos)) {
                        $filtros[] = ['ANI', 'LIKE', "%{$datos['origen']}%"];
                    }
                    if (array_key_exists('extension', $datos)) {
                        $filtros[] = ['extension', 'LIKE', "%{$datos['extension']}%"];
                    }
                    if (array_key_exists('segundosinicial', $datos) && $datos['segundosinicial'] != null) {
                        $filtros[] = ['duracion', '>=', $datos['segundosinicial'] + $datos['minutosinicial'] * 60 + $datos['horasinicial'] * 3600];
                    }
                    if (array_key_exists('segundosfinal', $datos) && $datos['segundosfinal'] != null) {
                        $filtros[] = ['duracion', '<=', $datos['segundosfinal'] + $datos['minutosfinal'] * 60 + $datos['horasfinal'] * 3600];
                    }
                    $results = DB::connection('Dialvox')->table('aurolog_grabaciones')->where($filtros)->where(function ($q) use ($datos) {
                        if (array_key_exists('inicio', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)=?", [date('Y-m-d', strtotime($datos['fin']))])->whereRaw('sec_to_time(hora)>=?', [date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}"))]);
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)<", [date('Y-m-d', strtotime($datos['fin']))]);
                            });
                        }
                        if (array_key_exists('fin', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)=?", [date('Y-m-d', strtotime($datos['fin']))])->whereRaw('sec_to_time(hora)<=?', [date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}"))]);
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)>", [date('Y-m-d', strtotime($datos['fin']))]);
                            });
                        }
                        if (array_key_exists('destino', $datos)) {
                            $q->whereRaw("CONCAT(DNIS,' ',digitos) LIKE '?%'", [$datos['destino']]);
                        }
                    })->limit(1000);
                    $results = $results->addSelect('idGrabacion')->addSelect('ANI')->addSelect(DB::raw("CONCAT(DNIS,' ',digitos) as 'Destino'"))->addSelect(DB::raw("sec_to_time(hora) as 'horai'"))->addSelect(DB::raw("sec_to_time(hora+duracion) as 'horaf'"))->addSelect(DB::raw("sec_to_time(duracion) as 'duracion'"))->addSelect('extension')->addSelect(DB::raw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY) as 'fecha'"))->addSelect(DB::raw("substr(archivoVoz,Locate('/2',archivoVoz)+1) as 'GRAB_FILE'"))->addSelect(DB::raw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) as 'GRAB_ID'"))->orderByRaw('idunico DESC')->get();
                    foreach ($results as $result) {
                        if (\file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                            if (unlink(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                DB::connection('Dialvox')->table('aurolog_grabaciones')->where('idGrabacion', '=', "$result->idGrabacion")->delete();
                                DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->extension: Fecha: $result->fecha Hora: $result->horai"]);
                            } else {
                                $errores[] = "No se pudo borrar la grabacion: '$result->GRAB_ID'";
                            }
                        } else {
                            $errores[] = "No existe el archivo de la grabacion: '$result->GRAB_ID'";
                        }
                    }
                    break;
                case 1:
                    $datos = $request->validate([
                        'nombre' => 'string',
                        'extension' => 'numeric',
                        'origen' => 'string',
                        'destino' => 'numeric',
                        'segundosinicial' => 'between:0,59|numeric|required_with_all:minutosinicial,horasinicial',
                        'minutosinicial' => 'between:0,59|numeric|required_with_all:segundosinicial,horasinicial',
                        'horasinicial' => 'between:0,23|numeric|required_with_all:minutosinicial,segundosinicial',
                        'segundosfinal' => 'between:0,59|numeric|required_with_all:minutosfinal,horasfinal',
                        'minutosfinal' => 'between:0,59|numeric|required_with_all:segundosfinal,horasfinal',
                        'horasfinal' => 'between:0,23|numeric|required_with_all:minutosfinal,segundosfinal',
                        'inicio' => 'before_or_equal:today|date|required_with_all:fminutosinicial,fhorasinicial,fsegundosinicial',
                        'fin' => 'after_or_equal:inicio|before_or_equal:today|date|required_with_all:fminutosfinal,fhorasfinal,fsegundosfinal',
                        'fminutosinicial' => 'between:0,59|numeric|required_with_all:fminutosinicial,fhorasinicial,inicio',
                        'fminutosinicial' => 'between:0,59|numeric|required_with_all:fsegundosinicial,fhorasinicial,inicio',
                        'fhorasinicial' => 'between:0,23|numeric|required_with_all:fminutosinicial,fsegundosinicial,inicio',
                        'fsegundosfinal' => 'between:0,59|numeric|required_with_all:fminutosfinal,fhorasfinal,fin',
                        'fminutosfinal' => 'between:0,59|numeric|required_with_all:fsegundosfinal,fhorasfinal,fin',
                        'fhorasfinal' => 'between:0,23|numeric|required_with_all:fminutosfinal,fsegundosfinal,fin',
                        'pagina' => 'gte:0|numeric|required',
                    ]);
                    $filtros = [];
                    if (array_key_exists('nombre', $datos) && $datos['nombre'] != null) {
                        $filtros[] = ['GRAB_ID', 'LIKE', "%{$datos['nombre']}%"];
                    }
                    if (array_key_exists('destino', $datos)) {
                        $filtros[] = ['GRAB_MACHINE', 'LIKE', "%{$datos['destino']}%"];
                    }
                    if (array_key_exists('origen', $datos)) {
                        $filtros[] = ['GRAB_IP', 'LIKE', "%{$datos['origen']}%"];
                    }
                    if (array_key_exists('extension', $datos)) {
                        $filtros[] = ['GRAB_EXT', 'LIKE', "%{$datos['extension']}%"];
                    }
                    if (array_key_exists('segundosinicial', $datos) && $datos['segundosinicial'] != null) {
                        $filtros[] = ['GRAB_DURATION', '>=', $datos['segundosinicial'] + $datos['minutosinicial'] * 60 + $datos['horasinicial'] * 3600];
                    }
                    if (array_key_exists('segundosfinal', $datos) && $datos['segundosfinal'] != null) {
                        $filtros[] = ['GRAB_DURATION', '<=', $datos['segundosfinal'] + $datos['minutosfinal'] * 60 + $datos['horasfinal'] * 3600];
                    }
                    $limit = $datos['pagina'] * 20;
                    $results = DB::connection('Dialvox')->table('grab')->where($filtros)->where(function ($q) use ($datos) {
                        if (array_key_exists('inicio', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('GRAB_TIME_S', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', '>', date('Y-m-d', strtotime($datos['inicio'])));
                            });
                        }
                        if (array_key_exists('fin', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', date('Y-m-d', strtotime($datos['fin'])))->whereTime('GRAB_TIME_S', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', '>', date('Y-m-d', strtotime($datos['fin'])));
                            });
                        }
                    })->limit(1000);
                    $results = $results->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_E,2),':',LEFT(RIGHT(GRAB_TIME_E,4),2),':',RIGHT(GRAB_TIME_E,2)) as 'GRAB_TIME_E'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),':',RIGHT(GRAB_TIME_S,2)) as 'GRAB_TIME_S'"))->addSelect(DB::raw("time(rl.end_time) AS 'HoraFin'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_DATE,4),'/',LEFT(RIGHT(GRAB_DATE,4),2),'/',RIGHT(GRAB_DATE,2)) as 'GRAB_DATE'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('GRAB_FILE')->addSelect('GRAB_IP')->addSelect('GRAB_ID')->addSelect('GRAB_MACHINE')->addSelect('GRAB_EXT')->addSelect(DB::raw("TIME_FORMAT(SEC_TO_TIME(GRAB_DURATION),'%H:%i:%s') as 'GRAB_DURATION'"))->orderByRaw("CONCAT(LEFT(GRAB_DATE,4),'-',LEFT(RIGHT(GRAB_DATE,4),2),'-',RIGHT(GRAB_DATE,2),' ',CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),'/:',RIGHT(GRAB_TIME_S,2))) DESC")->get();
                    foreach ($results as $result) {
                        if (\file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                            if (unlink(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                DB::connection('Dialvox')->table('grab')->where('GRAB_ID', '=', "$result->GRAB_ID")->delete();
                                DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 6, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " elimino la grabacion: $result->GRAB_ID Ext/Usuario: $result->GRAB_EXT: Fecha: $result->GRAB_DATE Hora: $result->GRAB_TIME_S"]);
                            } else {
                                $errores[] = "No se pudo borrar la grabacion: '$result->GRAB_ID'";
                            }
                        } else {
                            $errores[] = "No existe el archivo de la grabacion: '$result->GRAB_ID'";
                        }
                    }
                    break;
            }
            if (empty($errores)) {
                return ['Estado' => 'ok'];
            } else {
                return ['Estado' => 'error', 'Descripcion' => 'Hubo algunos errores borrando las grabaciones', 'Errores' => $errores];

            }
        }
    }
}
